{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit error_form;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, ExtCtrls, Spin, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnCallFunctionRTE: TButton;
    btnCallProcedureExcept: TButton;
    edtPosition: TSpinEdit;
    edtString: TLabeledEdit;
    lblPosition: TLabel;
    lblResultString: TLabel;
    procedure btnCallFunctionRTEClick(Sender: TObject);
    procedure btnCallProcedureExceptClick(Sender: TObject);
  private
   function OverwriteCharAtPosRTE(aChar: Char; var aString: string;
                                  aPos: integer): boolean;
   procedure OverwriteCharAtPosExcept(aChar: Char; var aString:
                                      string; aPos: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnCallFunctionRTEClick(Sender: TObject);
var s: string;
begin
  s := edtString.Text;
  if OverwriteCharAtPosRTE('Z', s, edtPosition.Value)
   then lblResultString.Caption := s
  else RunError(999);
end;

procedure TForm1.btnCallProcedureExceptClick(Sender: TObject);
var s: string;
begin
  s := edtString.Text;
  OverwriteCharAtPosExcept('Z', s, edtPosition.Value);
  lblResultString.Caption := s;
end;

function TForm1.OverwriteCharAtPosRTE(aChar: Char; var aString: string;
                                      aPos: integer): boolean;
var len: integer;
begin
  len := Length(aString);
  Result := (len <> 0) and (aPos > 0) and (aPos <= len);
  if Result then aString[aPos] := aChar;
end;

procedure TForm1.OverwriteCharAtPosExcept(aChar: Char; var aString: string;
                                          aPos: integer);
var len: integer;
begin
  len := Length(aString);
  if (len <> 0) and (aPos > 0) and (aPos <= len)
   then aString[aPos] := aChar
  else raise Exception.CreateFmt('Index (%d) out of range error in string "%s"',
                                 [aPos, aString]);
end;

end.

