{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit setdemo_main;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, ExtCtrls, Buttons, dualdigitsset;

type
  TButtonArr = array[TDigits] of TSpeedButton;

  { TMainForm }

  TMainForm = class(TForm)
    edtDiffZA: TLabeledEdit;
    edtSetA: TLabeledEdit;
    edtSetZ: TLabeledEdit;
    edtUnion: TLabeledEdit;
    edtIntersection: TLabeledEdit;
    edtSymmetricDiff: TLabeledEdit;
    edtDiffAZ: TLabeledEdit;
    pnlA: TPanel;
    pnlZ: TPanel;
    pnlResultSets: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    ds: TDualAZSet;
    function CreateButtons(setID: Char): TButtonArr;
    procedure ButtonClick(Sender: TObject);
    procedure UpdateSetExpressions;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ds:= TDualAZSet.Create;
  CreateButtons('A');
  CreateButtons('Z');
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  ds.Free;
end;

function TMainForm.CreateButtons(setID: Char): TButtonArr;
const spacing = 10;
	aLeft = 40;
var i: integer;
    b: TSpeedButton;

  procedure SetButtonProperties;
  begin
    b.Top := spacing;
         b.Left := aLeft + i * (b.Width + spacing);
         b.Caption := IntToStr(i);
         b.Tag := i;
         b.Name := Format('%s%d',[setID, i]);
         case setId of
          'A' : b.Parent := pnlA;
          'Z' : b.Parent := pnlZ;
         end;
         b.OnClick:= @ButtonClick;
  end;

begin
  for i := Low(TDigits) to High(TDigits) do
   begin
     b := TSpeedButton.Create(Self);
     SetButtonProperties;
     Result[i] := b;
   end;
end;

procedure TMainForm.ButtonClick(Sender: TObject);
var b: TSpeedButton;
begin
  if not (Sender is TSpeedButton) then Exit;
  b := TSpeedButton(Sender);
  case b.Name[1] of
   'A': begin
         if (b.Tag in ds.SetA)
          then ds.SetA:= ds.SetA - [b.Tag]
         else ds.SetA:= ds.SetA + [b.Tag];
         edtSetA.Caption := ds.SetAasText;
        end;
   'Z': begin
         if (b.Tag in ds.SetZ)
          then ds.SetZ:= ds.SetZ - [b.Tag]
         else ds.SetZ:= ds.SetZ + [b.Tag];
         edtSetZ.Caption := ds.SetZasText;
        end;
  end;
  UpdateSetExpressions;
end;

procedure TMainForm.UpdateSetExpressions;
begin
  edtUnion.Caption:= ds.UnionAsText;
  edtSymmetricDiff.Caption:= ds.SymDiffAsText;
  edtIntersection.Caption := ds.IntersectionAsText;
  edtDiffAZ.Caption := ds.DiffAZAsText;
  edtDiffZA.Caption := ds.DiffZAAsText;
end;

end.

